
require 'optparse'
require 'ostruct'

class MiniVMOptions
   def self.parse(args)
	options = OpenStruct.new
	options.src = "minivm.src"
	options.dst = "minivm.bin"
	options.verbose = false
	options.output = "Binary"

	opts = OptionParser.new do |opts|
		opts.banner = "Usage: minivmc [options]"
		opts.separator ""
		opts.separator "Suggested Options:"
		opts.on("-s","--source src","Source file to compile (#{options.src})") do |src|
			options.src = src
		end
		opts.on("-d","--destination dst","Destination file for binary (#{options.dst})") do |dst|
			options.dst = dst
		end
		opts.on("-v","--verbose","Show disassembled opcodes per line") do 
			options.verbose = true
		end
		opts.on("-o","--output style","Output style. [ Bin, C, MASM ]") do |style|
			options.output = style
		end
		opts.on_tail("-h","--help","Show this message") do
			puts opts
			exit
		end
		
	end
	opts.parse!(args)
	options
   end
end
