class VMOpcode
  attr_reader :cmd, :arg1, :arg2, :bytes
  attr_writer :cmd, :arg1, :arg2, :bytes
  def initialize(cmd, arg1, arg2, bytes)
	@cmd = cmd
	@arg1 = arg1
	@arg2 = arg2
	@bytes = bytes
  end
   
  def argcount
	return 0 if not @arg1
	return 1 if not @arg2
	return 2
  end

  def match(tok)
	matchfound = false
	if tok.operand == @cmd
		return true if tok.arg1 == @arg1 and tok.arg2 == @arg2
		if tok.arg1.is_a? VMValue or tok.arg1.is_a? VMLabel and
			@arg1 == :value and tok.arg2 == @arg2
				return true
		end
		if tok.arg2.is_a? VMValue or tok.arg2.is_a? VMLabel and
			@arg2 == :value and tok.arg1 == @arg1
				return true
		end
	end
	matchfound
  end

  def to_s
	out = String.new
	out if not @cmd
	out = @cmd
	if @arg1
		if @arg1 == :value
			out += " <value>"
		else
			out += " " + @arg1
		end
	end
	if @arg2
		if @arg2 == :value
			out += ", <value>"
		else
			out += ", " + @arg2
		end
	end
	out
  end

end

class VMOpcodes
  attr_reader :opcodes
  attr_writer :opcodes
  def initialize
	@opcodes = Array.new
  end

  def add(cmd, arg1, arg2, bytes)
	@opcodes.push(VMOpcode.new(cmd, arg1, arg2, bytes))
  end

end


